<?php
error_reporting(E_ALL);
$showError=false;
ini_set('display_errors', $showError);
ini_set('display_startup_errors', $showError);
class flow {
    public static function writeLog($log, $message) {
        $myfile = fopen($log, "a");
        fwrite($myfile, $message . "
");
        fclose($myfile);
    }
    public static function redCurrentPageUrl()
    {
        $pageURL = 'http';
        if (@$_SERVER["HTTPS"] == "on") {
            $pageURL .= "s";
        }
        $pageURL .= "://";

        if(!isset($_SERVER["SERVER_NAME"])&&isset($_SERVER["HTTP_HOST"]))
            return $pageURL .$_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

        if ($_SERVER["SERVER_PORT"] != "80") {
            $pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"] . $_SERVER["REQUEST_URI"];
        } else {
            $pageURL .= $_SERVER["SERVER_NAME"] . $_SERVER["REQUEST_URI"];
        }

        return $pageURL;
    }
    public static function getUserIp ()
    {
        $_SERVER['REMOTE_ADDR'] = isset($_SERVER["HTTP_CF_CONNECTING_IP"]) ? $_SERVER["HTTP_CF_CONNECTING_IP"] : $_SERVER["REMOTE_ADDR"];

        if ($_SERVER['REMOTE_ADDR'] != "127.0.0.1")
            return $_SERVER['REMOTE_ADDR'];

        if (isset ($_SERVER['HTTP_X_FORWARD_FOR']))
            $ip = $_SERVER['HTTP_X_FORWARD_FOR'];
        else
            $ip = $_SERVER['REMOTE_ADDR'];

        if ($ip == "127.0.0.1")
        {
            if (isset ($_SERVER["HTTP_X_REAL_IP"]))
                $ip = $_SERVER["HTTP_X_REAL_IP"];
        }
        return $ip;
    }
    public static function isMoreBotRecognition ($ip)
    {
        $hostname = strtolower(gethostbyaddr($ip));
        $fileUserAgents="google,yandex,mail.ru,bing";
        foreach(explode(",",$fileUserAgents) as $search_ag)
        {
            if (strpos($hostname,$search_ag)!==false)
                return "DA";
        }
        return "NET";
    }
    public static function getUserType ()
    {
        $userAgent = strtolower($_SERVER["HTTP_USER_AGENT"]);
        $agents="bingpreview,adidxbot,bingbot,slurp,yahoo,yahooseeker,googlebot,google.com,yandexbot,yandex.com,mail.ru,yandexmetrika,YandexForDomain,YandexImages,YandexImageResizer,YandexMobileBot,YandexMarket,bots,YandexMedia,YandexNews,YandexOntoDB,YandexSpravBot,YandexVertis,YandexVideo,YandexWebmaster,YandexScreenshotBot,YandexMedianaBot,YandexAccessibilityBot,YandexAdNet,YandexBlogs,YandexCalendar,YandexCatalog,YandexDirect,YandexFavicons,YandexDirectDyn,YaDirectFetcher,YandexOntoDBAPI,YandexPagechecker,YandexSearchShop,YandexSitelinks,YandexTurbo";
        $userSearchLists=strtolower($agents);
        foreach(explode(",",$userSearchLists) as $user)
        {
            if(trim($user)=='')
                continue;

            if (strpos(trim($userAgent), $user)!==false)
                return "searchbot";
        }
        if (strpos(trim($userAgent), "bot")!==false)
            return "bot";

        return "user";
    }
    public function write($dir)
    {
        $ip=flow::getUserIp();
        $bot=flow::getUserType();
        $currentUrl=flow::redCurrentPageUrl();
        $fingerpring="empty";
        if(isset($_GET["f_pring"]))
            $fingerpring=$_GET["f_pring"];
        if(isset($_GET["loc"]))
            $currentUrl=base64_decode($_GET["loc"]);

        $message=date("Y-m-d G:i")." | $currentUrl | $fingerpring | $ip | $bot | ". flow::isMoreBotRecognition($ip);

        if($fingerpring=="empty")
        {
            $log=$dir.'/visits.txt';
            if(filesize($log)>10000000)
                file_put_contents($log, '');
        }
        else{
            $log=$dir.'/fingerprints.txt';
            if(filesize($log)>10000000)
                file_put_contents($log, '');
        }
        flow::writeLog($log, $message);
    }
}
?>